-- (c) Xavier Ferrair Peir, aka Mortimer of Outland EU - Horde
-- no code in this file may be used in other works without expressed permission
local EventFrame = CreateFrame("Frame")
EventFrame:RegisterEvent("PLAYER_LOGIN")
EventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
EventFrame:RegisterEvent("PLAYER_LEAVING_WORLD")
EventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
EventFrame:RegisterEvent("PLAYTIME_CHANGED")

local tracker
local playerid

function killreporter()
	local zone = GetZoneText()
	local tname, trealm = UnitName("target");
	local isSame = UnitIsSameServer("player", "target")
	local realhk = (GetPVPSessionStats(honorKills) + 1)
	if ( isSame == 1 ) then
		print("has killed %T @ "..zone.." ("..realhk..")"); -- Player and target in same Realm
	else
		print("has killed %T - "..trealm.." @ "..zone.." ("..realhk..")"); -- Player and target in different Realm
	end
end

function zoneType()
	local inInstance, instanceType = IsInInstance()
	local zone = GetZoneText()
	local realhk = (GetPVPSessionStats(honorKills) + 1)
	local realtotalhk = (GetPVPLifetimeStats(hk) + 1)
	
	if inInstance and (instanceType == "party" or instanceType == "raid") then
		--PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\headshot.mp3");
	elseif inInstance and (instanceType == "pvp" or instanceType == "arena") then
		--PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\headshot.mp3");
	elseif not inInstance and (zone=="Orgrimmar" or zone=="Thunder Bluff" or zone=="Cima del Trueno" or zone=="Undercity" or zone=="Entraas" or zone=="Silvermoon City" or zone=="Ciudad de Lunargenta" or zone=="Stormwind City" or zone=="Ventormenta" or zone=="Ironforge" or zone=="Forjaz" 
		or zone == "Darnassus" or zone == "Exodar") then
		killreporter();
		--SendChatMessage("%T got killed by "..UnitName("player").." on "..zone.." ("..realhk..")", "GUILD", NIL);
		--PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\headshot.mp3");
	elseif not inInstance and (zone=="Dalaran" or zone=="Shattrath City" or zone=="Ciudad de Shattrath" or zone=="Darkmoon Island" or zone=="Isla Luna Negra") then
		killreporter();
		--SendChatMessage("%T got killed by "..UnitName("player").." on "..zone.." ("..realhk..")", "GUILD", NIL);
		--PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\headshot.mp3");
	else
		killreporter();
		--SendChatMessage("%T got killed by "..UnitName("player").." on "..zone.." ("..realhk..")", "GUILD", NIL);
		--PlaySoundFile("Interface\\AddOns\\Bang_Bang\\Artwork\\headshot.mp3");
	end
end

local function SetUpTracker()
		
		tracker = CreateFrame("Frame")
		--tracker:HookScript("OnEvent", function(self, event)
		tracker:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		tracker:SetScript("OnEvent", function(_, _, _, event, _, guid, _, _, _, _, destName, destFlags)
		if event == "PARTY_KILL" and guid==playerid and bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) > 0 then
		zoneType();
		end
		end)
end

EventFrame:SetScript("OnEvent", function(self, event, ...)
	local zone = GetZoneText();

		if event == "PLAYER_LOGIN" then
				playerid = UnitGUID("player")
				SetUpTracker()
		end
end)